import ocean.Coordinate;
import ocean.Direction;
import ocean.Ocean;
import ocean.Traversal;

/***********************************
 * Question 2 : parcours en largeur
 ***********************************/

/**
 * Une classe abstraite, qui étend {@link Traversal} avec le rebroussement
 * de chemin (Question 2.3)
 */
abstract class BackTrackingTraversal extends Traversal {
	/**
	 * Implémente le rebroussement de chemin
	 * 
	 * @param ocean   l'océan en train d'être exploré
	 * @param current le point de départ du rebroussement, c'est-à-dire la cellule
	 *                où l'exploration s'était arrêtée
	 */
	void backTrack(Ocean ocean, Coordinate current) {
		// TODO: Implémenter le rebroussement de chemin en supposant que les cellules 
		// 	     de l'océan sont marquées avec les directions à suivre
		
		// @OFF
		// tant qu'on n'a pas épuisé les possibilités de rebroussement
		// et qu'on n'ait pas retrouvé start
		if (current == null)
			return;

		// on récupère la direction stocké dans la marque de la cellule courante
		Direction dir = getDirection(ocean, current);
		while (current != null && dir != null) {
			// on récupère la cellule voisine dans cette direction
			Coordinate prev = current.moveTo(dir);
			// on marque la cellule courante comme faisant partie du chemin vers Nemo
			ocean.setMark(current, path);
			// puis on rebrousse le chemin vers la case voisine récupérée plus haut
			current = prev;
			// on met à jour la direction à partir de la cellule courante
			dir = getDirection(ocean, current);
		}
		/* @ON
		throw new Error("Méthode BackTrackingTraversal.backTrack(Ocean, Coordinate, Coordinate) à implémenter (Question 2.3)");
		@OFF @ON */ 
	}
}
