import ocean.Coordinate;

/**
 * Une classe pour associer la distance au requin le plus proche et à Marin à
 * une cellule
 */
class CellShark implements Comparable<CellShark> {
	// @OFF
	/**
	 * La cellule
	 */
	Coordinate cell;

	/**
	 * Distance à la case de départ (Marin)
	 */
	int startDist;

	/**
	 * Distance au requin le plus proche
	 */
	int sharkDist;

	/**
	 * Le constructeur
	 * 
	 * @param cell      la cellule
	 * @param startDist distance à la case de départ (Marin)
	 * @param sharkDist distance au requin le plus proche
	 */
	public CellShark(Coordinate cell, int startDist, int sharkDist) {
		this.cell = cell;
		this.startDist = startDist;
		this.sharkDist = sharkDist;
	}
	// @ON
	
	/**
	 * Comparaison avec un autre objet de la même classe.
	 * 
	 * <p>
	 * Compare les distinces aux requins, puis, en cas d'égalité, celles à Marin.
	 * </p>
	 */
	public int compareTo(CellShark c) {
		// @OFF
		if (sharkDist != c.sharkDist)
			return sharkDist - c.sharkDist;
		else // sharkDist == c.sharkDist
			return startDist - c.startDist;
		/* @ON
		throw new Error("Méthode CellShark.compareTo(CellShark) à implémenter (Question 4)");
		@OFF @ON */
	}
}
 